<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="author" content="Nicolas H.-P. De Coster">
    <title>GitLab JSON</title>
    <script src="https://cdn.jsdelivr.net/npm/alasql@1.7"></script>
    <script
        src="https://code.jquery.com/jquery-3.6.0.min.js"
        integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4="
        crossorigin="anonymous"></script>
    <script src="./gitLabClass.js"></script>
    <script src="./JSONToHTMLList.js"></script>
    <style>
      input, textarea, select {
        display:block;
        margin-bottom: 12px;
      }
      dl {
        display: grid;
        grid-template-columns: auto auto;
      }

      dt {
        grid-column: 1;
      }

      dd {
        grid-column: 2;
      }
      
/*      dt:nth-of-type(even), dd:nth-of-type(even) {
        background: lightgrey;
      }*/
    </style>
<!--     <link rel="stylesheet" href="style.css"> -->
  </head>
  <body>
    <div id="divForm">
      <label for="files">JSON files</label>
      <input type="file" id="files" accept="application/JSON" name="files[]" multiple>
      <label for="token">GitLab Token</label>
      <input type="password" id="token" name="token" value="">
      <label for="Group ID">Group ID</label>
      <input type="number" id="groupID" value="13532438">
      <output id="list"></output>
    </div>
      <button id="testButton" onclick="test()">Test</button>
    <div id="divDescription">
    </div>
    <div id="divTest">
    </div>
    <script>

    //When the page is ready
    $(function(){
      var divDescription  = $("#divDescription");
      var divForm         = $("#divForm");
      
      var selAccessProj = $('<select>').prop('id', 'accessLvlProj');
      $(gitLab.accessLvl).each(function(key, val){
        selAccessProj.append(
          $("<option>")
            .attr('value',this.val)
            .text(this.text)
        );
      });
      
      divForm
        .append(
          $('<label>')
          .prop('for', 'accessLvl')
          .text('Access level for own project')
        )
        .append(selAccessProj)
    });
    
    function JSONOptions(obj){
      var html = "";
      for(var key in obj) {
          html += "<option value=" + key  + ">" +obj[key] + "</option>"
      }
      return html;
    }

    function test(){
      const token   = $("#token").val();
      const groupID = $("#groupID").val();
            
      var divDescription  = $("#divDescription");
      var divForm         = $("#divForm");
      
      var myClass = new gitLabClassGroup(token, groupID);

      
      //Set member right in project
      //Denis ID : 3023400
      //My test project : 22862946
//       myClass.conn.setMember(22862946, 3023400, 30);
      
      console.log(myClass.shortDesc());
      $("#divTest").html(JSONToHTMLList(myClass.shortDesc()));
/*
      console.log(myClass.students);
      console.log(myConn.getGroup(groupID));
      console.log(myConn.getSubgroups(groupID));
      console.log(myConn.getProjects(groupID));
      const studentsGroup = myConn.getSubgroupWithName(groupID, "students");
      console.log(studentsGroup);
 */   }
    
      //credit : http://jsfiddle.net/Noitidart/zTe4j/3/
      //modified by Nicolas H.-P. De Coster
      function handleFileSelect(evt) {
        var files = evt.target.files; // FileList object
        // files is a FileList of File objects. List some properties.
      }
      
      function handleJSON(json){
        console.log(json);
      }
      
      document.getElementById('files')
              .addEventListener('change', handleFileSelect, false);
      function handleFileSelect(evt) {
        var files = evt.target.files; // FileList object

        // files is a FileList of File objects. List some properties.
        var output = [];
        for (var i = 0, f; f = files[i]; i++) {
          var reader = new FileReader();

          // Closure to capture the file information.
          reader.onload = (function (theFile) {
            return function (e) {
//               console.log('e readAsText = ', e);
//               console.log('e readAsText target = ', e.target);
              try {
                json = JSON.parse(e.target.result);
                if(Array.isArray(json)){
                  handleJSON(json);
//                   output = [].concat(output, json);
                }
                else{
                  console.error("Json file is not an array : " 
                                + JSON.stringify(json));
                }
//                 console.log(json);
              } catch (ex) {
                alert('Error while parsing json (see console error).');
                console.error('Error while parsing json = ' + ex);
              }
            }
          })(f);
          reader.readAsText(f);
        }
      }

      document.getElementById('files').addEventListener('change', handleFileSelect, false);    
    </script>
  </body>
</html>
